searchNodes=[{"doc":"The Hike module provides an implementation of the Optional data types. It defines a struct Hike.Option with a single field value which can either be nil or any other value of type t . a struct Hike.Either that represents an &quot;either/or&quot; value. It can contain either a left value or a right value, but not both a struct Hike.MayFail that represents an &quot;either/or&quot; value. It can contain either a Failure value or a Success value, but not both. This implementation provides shorthand functions to work with Optional data, including mapping, filtering, applying and many more functions to the value inside the Optional data.","ref":"Hike.html","title":"Hike","type":"module"},{"doc":"","ref":"Hike.html#apply/2","title":"Hike.apply/2","type":"function"},{"doc":"","ref":"Hike.html#apply_failure/2","title":"Hike.apply_failure/2","type":"function"},{"doc":"","ref":"Hike.html#apply_left/2","title":"Hike.apply_left/2","type":"function"},{"doc":"","ref":"Hike.html#apply_right/2","title":"Hike.apply_right/2","type":"function"},{"doc":"","ref":"Hike.html#apply_success/2","title":"Hike.apply_success/2","type":"function"},{"doc":"","ref":"Hike.html#bind/2","title":"Hike.bind/2","type":"function"},{"doc":"","ref":"Hike.html#bind_failure/2","title":"Hike.bind_failure/2","type":"function"},{"doc":"","ref":"Hike.html#bind_left/2","title":"Hike.bind_left/2","type":"function"},{"doc":"","ref":"Hike.html#bind_right/2","title":"Hike.bind_right/2","type":"function"},{"doc":"","ref":"Hike.html#bind_success/2","title":"Hike.bind_success/2","type":"function"},{"doc":"","ref":"Hike.html#either/1","title":"Hike.either/1","type":"function"},{"doc":"","ref":"Hike.html#failure/1","title":"Hike.failure/1","type":"function"},{"doc":"","ref":"Hike.html#filter/2","title":"Hike.filter/2","type":"function"},{"doc":"","ref":"Hike.html#left/1","title":"Hike.left/1","type":"function"},{"doc":"","ref":"Hike.html#map/2","title":"Hike.map/2","type":"function"},{"doc":"","ref":"Hike.html#map_failure/2","title":"Hike.map_failure/2","type":"function"},{"doc":"","ref":"Hike.html#map_left/2","title":"Hike.map_left/2","type":"function"},{"doc":"","ref":"Hike.html#map_right/2","title":"Hike.map_right/2","type":"function"},{"doc":"","ref":"Hike.html#map_success/2","title":"Hike.map_success/2","type":"function"},{"doc":"","ref":"Hike.html#match/3","title":"Hike.match/3","type":"function"},{"doc":"","ref":"Hike.html#mayfail/1","title":"Hike.mayfail/1","type":"function"},{"doc":"","ref":"Hike.html#option/0","title":"Hike.option/0","type":"function"},{"doc":"","ref":"Hike.html#option/1","title":"Hike.option/1","type":"function"},{"doc":"","ref":"Hike.html#right/1","title":"Hike.right/1","type":"function"},{"doc":"","ref":"Hike.html#success/1","title":"Hike.success/1","type":"function"},{"doc":"wraps a function call if function runs successfully will return MayFail in Success state otherwise return MayFail in Failure state.","ref":"Hike.html#try/1","title":"Hike.try/1","type":"function"},{"doc":"wraps a function with arity 1 call if function runs successfully will return MayFail in Success state otherwise return MayFail in Failure state. Example iex&gt; add1 = fn ( x ) -&gt; x + 1 end iex&gt; Hike . try ( add1 , 5 ) |&gt; Hike.MayFail . map_success ( fn x -&gt; x end ) % Hike.MayFail { failure : nil , success : 6 , is_success? : true }","ref":"Hike.html#try/2","title":"Hike.try/2","type":"function"},{"doc":"wraps a function with arity 2 call if function runs successfully will return MayFail in Success state otherwise return MayFail in Failure state. Example iex&gt; divide = fn ( x , y ) -&gt; x / y end iex&gt; Hike . try ( divide , 5 , 0 ) |&gt; ...&gt; Hike.MayFail . map_success ( fn x -&gt; { :ok , x + 1 } end ) |&gt; ...&gt; Hike.MayFail . map_failure ( fn x -&gt; String . upcase ( x ) end ) % Hike.MayFail { failure : &quot;BAD ARGUMENT IN ARITHMETIC EXPRESSION&quot; , success : nil , is_success? : false }","ref":"Hike.html#try/3","title":"Hike.try/3","type":"function"},{"doc":"wraps a function with arity 3 call if function runs successfully will return MayFail in Success state otherwise return MayFail in Failure state.","ref":"Hike.html#try/4","title":"Hike.try/4","type":"function"},{"doc":"wraps a function with arity 4 call if function runs successfully will return MayFail in Success state otherwise return MayFail in Failure state.","ref":"Hike.html#try/5","title":"Hike.try/5","type":"function"},{"doc":"","ref":"Hike.html#t:exception/0","title":"Hike.exception/0","type":"type"},{"doc":"generic input type &lt;T&gt; .","ref":"Hike.html#t:t/0","title":"Hike.t/0","type":"type"},{"doc":"generic input type &lt;TArg1&gt; .","ref":"Hike.html#t:tArg1/0","title":"Hike.tArg1/0","type":"type"},{"doc":"generic input type &lt;TArg2&gt; .","ref":"Hike.html#t:tArg2/0","title":"Hike.tArg2/0","type":"type"},{"doc":"generic input type &lt;TArg3&gt; .","ref":"Hike.html#t:tArg3/0","title":"Hike.tArg3/0","type":"type"},{"doc":"generic input type &lt;TArg4&gt; .","ref":"Hike.html#t:tArg4/0","title":"Hike.tArg4/0","type":"type"},{"doc":"generic return type &lt;TR&gt; .","ref":"Hike.html#t:tr/0","title":"Hike.tr/0","type":"type"},{"doc":"","ref":"Hike.Either.html","title":"Hike.Either","type":"module"},{"doc":"%Hike.Either{l_value: t_left(), r_value: t_right(), is_left?:boolean()} is a struct that represents an &quot;either/or&quot; value. It can contain either a left value or a right value, but not both. l_value : the left value (if is_left? is true) r_value : the right value (if is_left? is false) is_left? : a boolean flag indicating whether the value is a left value ( true ) or a right value ( false )","ref":"Hike.Either.html#__struct__/0","title":"Hike.Either.__struct__/0","type":"function"},{"doc":"apply_left applies a given function to a given Either if Either is in left state and return a new Either with new transformed value in Left state else return new Either in Right state with existing right value. Examples iex&gt; ( Either . left 5 ) |&gt; Either . apply_left ( fn num -&gt; num + num end ) % Hike.Either { l_value : 10 , r_value : nil , is_left? : true } iex&gt; ( Either . right 5 ) |&gt; Either . apply_left ( fn num -&gt; num + num end ) % Hike.Either { l_value : nil , r_value : 5 , is_left? : false }","ref":"Hike.Either.html#apply_left/2","title":"Hike.Either.apply_left/2","type":"function"},{"doc":"apply_right applies a given function to a given Either if Either is in right state and return a new Either with new transformed value in Right state else return new Either in Left state with existing left value. Examples iex&gt; ( Either . right &quot;hello&quot; ) |&gt; Either . apply_right ( fn str -&gt; String . upcase ( str ) end ) % Hike.Either { l_value : nil , r_value : &quot;HELLO&quot; , is_left? : false } iex&gt; ( Either . left &quot;hello&quot; ) |&gt; Either . apply_right ( fn str -&gt; String . upcase ( str ) end ) % Hike.Either { l_value : &quot;hello&quot; , r_value : nil , is_left? : true }","ref":"Hike.Either.html#apply_right/2","title":"Hike.Either.apply_right/2","type":"function"},{"doc":"Binds a function that returns an Either value for an Either in the left state. If the input Either is in the right state, the function is not executed and the input Either is returned as is. Examples iex&gt; ( Either . left &quot;hello&quot; ) |&gt; Either . bind_left ( fn str -&gt; Either . left ( String . upcase ( str ) ) end ) % Hike.Either { l_value : &quot;HELLO&quot; , r_value : nil , is_left? : true } iex&gt; ( Either . left &quot;hello&quot; ) |&gt; Either . bind_left ( fn str -&gt; Either . right ( String . upcase ( str ) ) end ) % Hike.Either { l_value : nil , r_value : &quot;HELLO&quot; , is_left? : false } iex&gt; ( Either . right &quot;hello&quot; ) |&gt; Either . bind_left ( fn str -&gt; Either . left ( String . upcase ( str ) ) end ) % Hike.Either { l_value : nil , r_value : &quot;hello&quot; , is_left? : false }","ref":"Hike.Either.html#bind_left/2","title":"Hike.Either.bind_left/2","type":"function"},{"doc":"Binds a function that returns an Either value to an Either in the right state. If the input Either is in the left state, the function is not executed and the input Either is returned as is. Examples iex&gt; ( Either . right &quot;hello&quot; ) |&gt; Either . bind_right ( fn str -&gt; Either . right ( String . upcase ( str ) ) end ) % Hike.Either { l_value : nil , r_value : &quot;HELLO&quot; , is_left? : false } iex&gt; ( Either . right &quot;hello&quot; ) |&gt; Either . bind_right ( fn str -&gt; Either . left ( String . upcase ( str ) ) end ) % Hike.Either { l_value : &quot;HELLO&quot; , r_value : nil , is_left? : true } iex&gt; ( Either . left &quot;hello&quot; ) |&gt; Either . bind_right ( fn str -&gt; Either . right ( String . upcase ( str ) ) end ) % Hike.Either { l_value : &quot;hello&quot; , r_value : nil , is_left? : true }","ref":"Hike.Either.html#bind_right/2","title":"Hike.Either.bind_right/2","type":"function"},{"doc":"Create new Either from result. if result is {:ok, val} Either will be in right state. else if result is {:error, val} Either will be in left state. with respective value val in respective side.","ref":"Hike.Either.html#from_result/1","title":"Hike.Either.from_result/1","type":"function"},{"doc":"Check whether an either is in Left state or not . Examples iex&gt; right ( &quot;foo bar&quot; ) |&gt; Either . is_left? ( ) false iex&gt; left ( &quot;foo bar&quot; ) |&gt; Either . is_left? ( ) true","ref":"Hike.Either.html#is_left?/1","title":"Hike.Either.is_left?/1","type":"function"},{"doc":"","ref":"Hike.Either.html#is_not_nil/1","title":"Hike.Either.is_not_nil/1","type":"macro"},{"doc":"Check whether an either is in Right state or not . Examples iex&gt; right ( &quot;foo bar&quot; ) |&gt; Either . is_right? ( ) true iex&gt; left ( &quot;foo bar&quot; ) |&gt; Either . is_right? ( ) false","ref":"Hike.Either.html#is_right?/1","title":"Hike.Either.is_right?/1","type":"function"},{"doc":"Creates a new Left Either object with a given value for the left side. Examples iex&gt; left ( &quot;foo bar&quot; ) % Hike.Either { l_value : &quot;foo bar&quot; , r_value : nil , is_left? : true }","ref":"Hike.Either.html#left/1","title":"Hike.Either.left/1","type":"function"},{"doc":"Maps the value of the Either from left state using the given function. If the Either is in the right state, the function returns the Either unchanged. If the Either is in the left state, the function applies the given function to the value of the left state, and returns a new Either with the transformed value. Examples iex&gt; ( Either . left 5 ) |&gt; Either . map_left ( fn num -&gt; num + num end ) % Hike.Either { l_value : 10 , r_value : nil , is_left? : true } iex&gt; ( Either . right 5 ) |&gt; Either . map_left ( fn num -&gt; num + num end ) % Hike.Either { l_value : nil , r_value : 5 , is_left? : false } iex&gt; either = % Either { l_value : &quot;hello&quot; , is_left? : true } iex&gt; new_either = Either . map_left ( either , &amp; String . upcase / 1 ) % Hike.Either { l_value : &quot;HELLO&quot; , is_left? : true } iex&gt; either = % Either { r_value : 10 , is_left? : false } iex&gt; new_either = Either . map_left ( either , &amp; String . downcase / 1 ) % Hike.Either { r_value : 10 , is_left? : false }","ref":"Hike.Either.html#map_left/2","title":"Hike.Either.map_left/2","type":"function"},{"doc":"Maps the value of the Either from right state using the given function. If the Either is in the left state, the function returns the Either unchanged. If the Either is in the right state, the function applies the given function to the value of the right state, and returns a new Either with the transformed value. Examples iex&gt; ( Either . right &quot;hello&quot; ) |&gt; Either . map_right ( fn str -&gt; String . upcase ( str ) end ) % Hike.Either { l_value : nil , r_value : &quot;HELLO&quot; , is_left? : false } iex&gt; ( Either . left &quot;hello&quot; ) |&gt; Either . map_right ( fn str -&gt; String . upcase ( str ) end ) % Hike.Either { l_value : &quot;hello&quot; , r_value : nil , is_left? : true }","ref":"Hike.Either.html#map_right/2","title":"Hike.Either.map_right/2","type":"function"},{"doc":"Matches an Either value and applies the corresponding function. Examples iex&gt; ( Either . left &quot;hello&quot; ) |&gt; Either . match ( fn str -&gt; String . upcase ( str ) end , fn ( ) -&gt; &quot;NOT FOUND&quot; end ) &quot;HELLO&quot; iex&gt; ( Either . right 4 ) |&gt; Either . match ( fn num -&gt; num * num end , fn num -&gt; num + num end ) 8","ref":"Hike.Either.html#match/3","title":"Hike.Either.match/3","type":"function"},{"doc":"Creates a new Either in Right state with a given value. Examples iex&gt; right ( &quot;foo bar&quot; ) % Hike.Either { l_value : nil , r_value : &quot;foo bar&quot; , is_left? : false }","ref":"Hike.Either.html#right/1","title":"Hike.Either.right/1","type":"function"},{"doc":"binder() represent a binding(mapping) function which take no parameter and return an Either of type &lt;TR&gt; . Example iex&gt; right_bind_func = fn ( ) -&gt; Either . right ( :ok ) end iex&gt; left_bind_func = fn ( ) -&gt; Either . left ( :ok ) end","ref":"Hike.Either.html#t:binder/0","title":"Hike.Either.binder/0","type":"type"},{"doc":"binder(t) represent a binding(mapping) function which take a parameter of type &lt;T&gt; and return an Either of type &lt;TR&gt; . Example iex&gt; right_bind_func = fn ( x ) -&gt; Either . right ( x ) end iex&gt; left_bind_func = fn ( y ) -&gt; Either . left ( y ) end","ref":"Hike.Either.html#t:binder/1","title":"Hike.Either.binder/1","type":"type"},{"doc":"represent a type of Either that could be in either Left or Right state","ref":"Hike.Either.html#t:either/0","title":"Hike.Either.either/0","type":"opaque"},{"doc":"represent a type of Either that could be in either Left or Right state with a value of given type.","ref":"Hike.Either.html#t:either/2","title":"Hike.Either.either/2","type":"type"},{"doc":"represent a type of Either in Left state.","ref":"Hike.Either.html#t:either_left/0","title":"Hike.Either.either_left/0","type":"type"},{"doc":"represent a type of Either in Left state.","ref":"Hike.Either.html#t:either_left/1","title":"Hike.Either.either_left/1","type":"type"},{"doc":"Elevated data type of Either struct that represents Right state.","ref":"Hike.Either.html#t:either_right/0","title":"Hike.Either.either_right/0","type":"type"},{"doc":"Elevated data type of Either struct that represents Right state and have a value of type &lt;T&gt; .","ref":"Hike.Either.html#t:either_right/1","title":"Hike.Either.either_right/1","type":"type"},{"doc":"func() represent a function which take no parameter and return value of type &lt;TR&gt; .","ref":"Hike.Either.html#t:func/0","title":"Hike.Either.func/0","type":"type"},{"doc":"func(t) represent a function which take a parameter of type &lt;T&gt; and return a value of type &lt;TR&gt; .","ref":"Hike.Either.html#t:func/1","title":"Hike.Either.func/1","type":"type"},{"doc":"mapper() represent a mapping function which take no parameter and return a value of type &lt;TR&gt; .","ref":"Hike.Either.html#t:mapper/0","title":"Hike.Either.mapper/0","type":"type"},{"doc":"mapper(t) represent a mapping function which take a parameter of type &lt;T&gt; and return a value of type &lt;TR&gt; .","ref":"Hike.Either.html#t:mapper/1","title":"Hike.Either.mapper/1","type":"type"},{"doc":"generic input type &lt;T&gt; .","ref":"Hike.Either.html#t:t/0","title":"Hike.Either.t/0","type":"type"},{"doc":"generic input type &lt;T_Left&gt; represent a type of value on Left state.","ref":"Hike.Either.html#t:t_left/0","title":"Hike.Either.t_left/0","type":"type"},{"doc":"generic input type &lt;T_Right&gt; represent a type of value on Right state.","ref":"Hike.Either.html#t:t_right/0","title":"Hike.Either.t_right/0","type":"type"},{"doc":"generic return type &lt;TR&gt; .","ref":"Hike.Either.html#t:tr/0","title":"Hike.Either.tr/0","type":"type"},{"doc":"","ref":"Hike.MayFail.html","title":"Hike.MayFail","type":"module"},{"doc":"%Hike.Mayfail{failure: t_failure(), success: t_success(), is_success?:boolean()} is a struct that represents an &quot;either/or&quot; value. It can contain either a Failure value or a Success value, but not both. failure : the failure value (if is_success? is false) success : the success value (if is_success? is true) is_success? : a boolean flag indicating whether the value is a success value ( true ) or a failure value ( false )","ref":"Hike.MayFail.html#__struct__/0","title":"Hike.MayFail.__struct__/0","type":"function"},{"doc":"Example iex&gt; apply_func = fn x -&gt; x + 2 end iex&gt; MayFail . failure ( 1 ) |&gt; MayFail . apply_failure ( apply_func ) % Hike.MayFail { failure : 3 , success : nil , is_success? : false } iex&gt; MayFail . success ( 1 ) |&gt; MayFail . apply_failure ( apply_func ) % Hike.MayFail { failure : nil , success : 1 , is_success? : true }","ref":"Hike.MayFail.html#apply_failure/2","title":"Hike.MayFail.apply_failure/2","type":"function"},{"doc":"Example iex&gt; apply_func = fn x -&gt; ( x + 2 ) end iex&gt; MayFail . failure ( 1 ) |&gt; MayFail . apply_success ( apply_func ) % Hike.MayFail { failure : 1 , success : nil , is_success? : false } iex&gt; MayFail . success ( 1 ) |&gt; MayFail . apply_success ( apply_func ) % Hike.MayFail { failure : nil , success : 3 , is_success? : true }","ref":"Hike.MayFail.html#apply_success/2","title":"Hike.MayFail.apply_success/2","type":"function"},{"doc":"Binds a function that returns a MayFail value for an MayFail in the Failure state. If the input is in the Success state, the function is not executed and the input is returned as it is. Example iex&gt; binder = fn x -&gt; MayFail . success ( x + 2 ) end iex&gt; MayFail . failure ( 1 ) |&gt; MayFail . bind_failure ( binder ) % Hike.MayFail { failure : nil , success : 3 , is_success? : true } iex&gt; binder = fn x -&gt; MayFail . failure ( x + 2 ) end iex&gt; MayFail . failure ( 1 ) |&gt; MayFail . bind_failure ( binder ) % Hike.MayFail { failure : 3 , success : nil , is_success? : false } iex&gt; MayFail . success ( 1 ) |&gt; MayFail . bind_failure ( binder ) % Hike.MayFail { failure : nil , success : 1 , is_success? : true }","ref":"Hike.MayFail.html#bind_failure/2","title":"Hike.MayFail.bind_failure/2","type":"function"},{"doc":"Binds a function that returns a MayFail value for an MayFail in the Failure state. If the input is in the Success state, the function is not executed and the input is returned as it is. Example iex&gt; binder = fn x -&gt; MayFail . success ( x + 2 ) end iex&gt; MayFail . failure ( 1 ) |&gt; MayFail . bind_success ( binder ) % Hike.MayFail { failure : 1 , success : nil , is_success? : false } iex&gt; MayFail . success ( 1 ) |&gt; MayFail . bind_success ( binder ) % Hike.MayFail { failure : nil , success : 3 , is_success? : true } iex&gt; binder = fn x -&gt; MayFail . failure ( x + 2 ) end iex&gt; MayFail . success ( 1 ) |&gt; MayFail . bind_success ( binder ) % Hike.MayFail { failure : 3 , success : nil , is_success? : false }","ref":"Hike.MayFail.html#bind_success/2","title":"Hike.MayFail.bind_success/2","type":"function"},{"doc":"","ref":"Hike.MayFail.html#failure/1","title":"Hike.MayFail.failure/1","type":"function"},{"doc":"Check whether MayFail is in Failure state or not. Example iex&gt; Hike.MayFail . success ( 4 ) |&gt; Hike.MayFail . is_failure? false iex&gt; Hike.MayFail . failure ( &quot;fail&quot; ) |&gt; Hike.MayFail . is_failure? true","ref":"Hike.MayFail.html#is_failure?/1","title":"Hike.MayFail.is_failure?/1","type":"function"},{"doc":"Check whether MayFail is in Success state or not. Example iex&gt; Hike.MayFail . success ( 4 ) |&gt; Hike.MayFail . is_success? true iex&gt; Hike.MayFail . failure ( &quot;fail&quot; ) |&gt; Hike.MayFail . is_success? false","ref":"Hike.MayFail.html#is_success?/1","title":"Hike.MayFail.is_success?/1","type":"function"},{"doc":"Example iex&gt; mapper = fn x -&gt; x + 2 end iex&gt; MayFail . failure ( 1 ) |&gt; MayFail . map_failure ( mapper ) % Hike.MayFail { failure : 3 , success : nil , is_success? : false } iex&gt; MayFail . success ( 1 ) |&gt; MayFail . map_failure ( mapper ) % Hike.MayFail { failure : nil , success : 1 , is_success? : true }","ref":"Hike.MayFail.html#map_failure/2","title":"Hike.MayFail.map_failure/2","type":"function"},{"doc":"Example iex&gt; mapper = fn x -&gt; ( x + 2 ) end iex&gt; MayFail . failure ( 1 ) |&gt; MayFail . map_success ( mapper ) % Hike.MayFail { failure : 1 , success : nil , is_success? : false } iex&gt; MayFail . success ( 1 ) |&gt; MayFail . map_success ( mapper ) % Hike.MayFail { failure : nil , success : 3 , is_success? : true }","ref":"Hike.MayFail.html#map_success/2","title":"Hike.MayFail.map_success/2","type":"function"},{"doc":"Matches an Mayfail value and applies the corresponding function. Example iex&gt; Hike.MayFail . success ( 4 ) |&gt; Hike.MayFail . match ( fn x -&gt; x + 3 end , fn y -&gt; y + 2 end ) 6","ref":"Hike.MayFail.html#match/3","title":"Hike.MayFail.match/3","type":"function"},{"doc":"","ref":"Hike.MayFail.html#success/1","title":"Hike.MayFail.success/1","type":"function"},{"doc":"binder() represent a binding(mapping) function which take no argument and return a Mayfail of type &lt;TR&gt; . Example iex&gt; success_bind_func = fn ( ) -&gt; Hike.MayFail . success ( :ok ) end iex&gt; failure_bind_func = fn ( ) -&gt; Hike.MayFail . failure ( :error ) end","ref":"Hike.MayFail.html#t:binder/0","title":"Hike.MayFail.binder/0","type":"type"},{"doc":"binder(t) represent a binding(mapping) function which take an argument of type &lt;T&gt; and return a Mayfail of type &lt;TR&gt; . Example iex&gt; success_bind_func = fn ( x ) -&gt; Mayfail . success ( x ) end iex&gt; failure_bind_func = fn ( y ) -&gt; Mayfail . failure ( y ) end","ref":"Hike.MayFail.html#t:binder/1","title":"Hike.MayFail.binder/1","type":"type"},{"doc":"func() represent a function which take no argument and return value of type &lt;TR&gt; .","ref":"Hike.MayFail.html#t:func/0","title":"Hike.MayFail.func/0","type":"type"},{"doc":"func(t) represent a function which take an argument of type &lt;T&gt; and return a value of type &lt;TR&gt; .","ref":"Hike.MayFail.html#t:func/1","title":"Hike.MayFail.func/1","type":"type"},{"doc":"mapper() represent a mapping function which take no argument and return a value of type &lt;TR&gt; .","ref":"Hike.MayFail.html#t:mapper/0","title":"Hike.MayFail.mapper/0","type":"type"},{"doc":"mapper(t) represent a mapping function which take an argument of type &lt;T&gt; and return a value of type &lt;TR&gt; .","ref":"Hike.MayFail.html#t:mapper/1","title":"Hike.MayFail.mapper/1","type":"type"},{"doc":"represent a type of Mayfail that could be in either Failure or Success state","ref":"Hike.MayFail.html#t:mayfail/0","title":"Hike.MayFail.mayfail/0","type":"opaque"},{"doc":"represent a type of Mayfail that could be in either failure or success state with a value of given type.","ref":"Hike.MayFail.html#t:mayfail/2","title":"Hike.MayFail.mayfail/2","type":"type"},{"doc":"represent a type of Mayfail in Failure state.","ref":"Hike.MayFail.html#t:mayfail_failure/0","title":"Hike.MayFail.mayfail_failure/0","type":"type"},{"doc":"represent a type of Mayfail in Failure state.","ref":"Hike.MayFail.html#t:mayfail_failure/1","title":"Hike.MayFail.mayfail_failure/1","type":"type"},{"doc":"Elevated data type of Mayfail struct that represents Success state.","ref":"Hike.MayFail.html#t:mayfail_success/0","title":"Hike.MayFail.mayfail_success/0","type":"type"},{"doc":"Elevated data type of Mayfail struct that represents Success state and have a value of type &lt;T&gt; .","ref":"Hike.MayFail.html#t:mayfail_success/1","title":"Hike.MayFail.mayfail_success/1","type":"type"},{"doc":"generic input type &lt;T&gt; .","ref":"Hike.MayFail.html#t:t/0","title":"Hike.MayFail.t/0","type":"type"},{"doc":"generic input type &lt;T_Failure&gt; represent a type of value on Failure state.","ref":"Hike.MayFail.html#t:t_failure/0","title":"Hike.MayFail.t_failure/0","type":"type"},{"doc":"generic input type &lt;T_Success&gt; represent a type of value on Success state.","ref":"Hike.MayFail.html#t:t_success/0","title":"Hike.MayFail.t_success/0","type":"type"},{"doc":"generic return type &lt;TR&gt; .","ref":"Hike.MayFail.html#t:tr/0","title":"Hike.MayFail.tr/0","type":"type"},{"doc":"The Hike.Option module provides an implementation of the Optional data type. It defines a struct Option with a single field value which can either be @none or any other value of type t . This implementation provides functions to work with Optional data, including mapping, filtering, applying and many more functions to the value inside the Optional data. Example Usage iex&gt; option = % Hike.Option { value : 42 } % Hike.Option { value : 42 } iex&gt; Hike.Option . map ( option , &amp; ( &amp;1 * 2 ) ) % Hike.Option { value : 84 } iex&gt; Hike.Option . filter ( option , &amp; ( rem ( &amp;1 , 2 ) == 0 ) ) % Hike.Option { value : 42 } iex&gt; Hike.Option . apply ( option , &amp; ( &amp;1 + 10 ) ) % Hike.Option { value : 52 } For more information on how to use this module, please see the documentation for the individual functions.","ref":"Hike.Option.html","title":"Hike.Option","type":"module"},{"doc":"Applies a given function to the value of an Option struct and returns the result as a new Option . OR Applies a given function stored in an option to the value of another option, and returns the result as a new option. Examples iex&gt; option = % Option { value : 42 } iex&gt; add_one = fn x -&gt; x + 1 end iex&gt; Option . apply ( option , add_one ) % Option { value : 43 } iex&gt; none_option = % Option { value : nil } iex&gt; Option . apply ( none_option , add_one ) % Option { value : nil } iex&gt; option = % Option { value : &quot;hello&quot; } iex&gt; upcase_string = fn str -&gt; String . upcase ( str ) end iex&gt; Option . apply ( option , upcase_string ) % Option { value : &quot;HELLO&quot; }","ref":"Hike.Option.html#apply/2","title":"Hike.Option.apply/2","type":"function"},{"doc":"Transforms an Option&lt;T&gt; struct with a non-nil value using a binder function that returns another Option&lt;TR&gt; struct. If the input Option has a nil value, returns a new Option struct with a nil value. if you have a function that return Option&lt;TR&gt; and you want to apply mapping then use bind function to avoid double elevation. Examples iex&gt; option = % Option { value : 42 } iex&gt; add_one = fn x -&gt; Option . some ( x + 1 ) end iex&gt; Option . bind ( option , add_one ) % Option { value : 43 } iex&gt; Option . bind ( Option . some ( &quot;hello&quot; ) , fn x -&gt; Option . some ( String . upcase ( x ) ) end ) % Option { value : &quot;HELLO&quot; } iex&gt; Option . bind ( Option . none ( ) ) % Option { value : nil }","ref":"Hike.Option.html#bind/2","title":"Hike.Option.bind/2","type":"function"},{"doc":"Applies the given function to the value of the provided option, returning a new option containing the original value if the function returns a truthy value, otherwise returning an empty option. If the provided option has no value, this function simply returns the empty option. Examples iex&gt; Option . filter ( % Option { value : 42 } , fn x -&gt; rem ( x , 2 ) == 0 end ) % Option { value : 42 } iex&gt; Option . filter ( % Option { value : 42 } , fn x -&gt; rem ( x , 2 ) == 1 end ) % Option { value : nil } iex&gt; Option . filter ( % Option { value : nil } , fn x -&gt; rem ( x , 2 ) == 0 end ) % Option { value : nil } iex&gt; list_opt = Option . some ( [ 1 , 2 , 3 ] ) iex&gt; list_filter = fn ( lst ) -&gt; Enum . count ( lst ) &gt; 5 end iex&gt; Option . filter ( list_opt , list_filter ) % Hike.Option { value : nil }","ref":"Hike.Option.html#filter/2","title":"Hike.Option.filter/2","type":"function"},{"doc":"Returns true if the Option is in None state, otherwise false . Examples iex&gt; Option . is_none? ( Option . none ( ) ) true iex&gt; Option . is_none? ( Option . some ( &quot;hello&quot; ) ) false","ref":"Hike.Option.html#is_none?/1","title":"Hike.Option.is_none?/1","type":"function"},{"doc":"Returns true if the Option is in Some state, otherwise false . Examples iex&gt; Option . is_some? ( Option . some ( &quot;hello&quot; ) ) true iex&gt; Option . is_some? ( Option . none ( ) ) false","ref":"Hike.Option.html#is_some?/1","title":"Hike.Option.is_some?/1","type":"function"},{"doc":"Applies the given mapping function to the value inside the Option struct and returns a new Option struct containing the transformed value. If the input Option struct is @none , the function returns a new Option struct in none state. ## Examples iex&gt; Option . map ( Option . some ( &quot;hello&quot; ) , fn x -&gt; String . upcase ( x ) end ) % Option { value : &quot;HELLO&quot; } iex&gt; Option . map ( Option . none ( ) , fn x -&gt; String . upcase ( x ) end ) % Option { value : nil }","ref":"Hike.Option.html#map/2","title":"Hike.Option.map/2","type":"function"},{"doc":"Matches on an option and returns the result of the matching function. Calls some_fun with the value of the Option if the Option is in :some state, or calls none_fun if the Option is in :none state. Examples iex&gt; import Hike.Option # Match on `some` value with a matching function iex&gt; match ( some ( 10 ) , &amp; ( &amp;1 * 2 ) ) # =&gt; 20 # Match on `none` value with a none-matching function iex&gt; match ( none ( ) , fn -&gt; &quot;no value&quot; end ) # =&gt; &quot;no value&quot; # Match on `some` value with a matching function and on `none` value with a none-matching function iex&gt; match ( some ( &quot;hello&quot; ) , &amp; ( &amp;1 &lt;&gt; &quot; world&quot; ) , fn -&gt; &quot;no value&quot; end ) # =&gt; &quot;hello world&quot; # Match on `none` value with a none-matching function even if a matching function is provided iex&gt; match ( none ( ) , &amp; ( &amp;1 * 2 ) , fn -&gt; &quot;no value&quot; end ) # =&gt; &quot;no value&quot; iex&gt; Option . match ( Option . some ( &quot;hello&quot; ) , fn x -&gt; String . upcase ( x ) end ) &quot;HELLO&quot; iex&gt; Option . match ( Option . none ( ) , fn -&gt; &quot;nothing&quot; end ) &quot;nothing&quot; iex&gt; Option . match ( Option . some ( &quot;hello&quot; ) , fn x -&gt; String . upcase ( x ) end , fn -&gt; &quot;nothing&quot; end ) &quot;HELLO&quot; iex&gt; Option . match ( Option . none ( ) , fn x -&gt; String . upcase ( x ) end , fn -&gt; &quot;nothing&quot; end ) &quot;nothing&quot;","ref":"Hike.Option.html#match/2","title":"Hike.Option.match/2","type":"function"},{"doc":"","ref":"Hike.Option.html#match/3","title":"Hike.Option.match/3","type":"function"},{"doc":"Creates an Option in None state. Examples iex&gt; Option . none ( ) % Option { value : :nil }","ref":"Hike.Option.html#none/0","title":"Hike.Option.none/0","type":"function"},{"doc":"Creates an Option in Some state Examples iex&gt; Option . some ( &quot;hello&quot; ) % Option { value : &quot;hello&quot; }","ref":"Hike.Option.html#some/1","title":"Hike.Option.some/1","type":"function"},{"doc":"binder() represent a binding(mapping) function which take no parameter and return an option of type &lt;TR&gt; .","ref":"Hike.Option.html#t:binder/0","title":"Hike.Option.binder/0","type":"type"},{"doc":"binder(t) represent a binding(mapping) function which take a parameter of type &lt;T&gt; and return an option of type &lt;TR&gt; .","ref":"Hike.Option.html#t:binder/1","title":"Hike.Option.binder/1","type":"type"},{"doc":"func() represent a function which take no parameter and return value of type &lt;TR&gt; .","ref":"Hike.Option.html#t:func/0","title":"Hike.Option.func/0","type":"type"},{"doc":"func(t) represent a function which take a parameter of type &lt;T&gt; and return a value of type &lt;TR&gt; .","ref":"Hike.Option.html#t:func/1","title":"Hike.Option.func/1","type":"type"},{"doc":"mapper() represent a mapping function which take no parameter and return a value of type &lt;TR&gt; .","ref":"Hike.Option.html#t:mapper/0","title":"Hike.Option.mapper/0","type":"type"},{"doc":"mapper(t) represent a mapping function which take a parameter of type &lt;T&gt; and return a value of type &lt;TR&gt; .","ref":"Hike.Option.html#t:mapper/1","title":"Hike.Option.mapper/1","type":"type"},{"doc":"Elevated data type of Option struct that represents None state.","ref":"Hike.Option.html#t:option/0","title":"Hike.Option.option/0","type":"type"},{"doc":"Elevated data type of Option struct that represents Some state and have a value of type &lt;T&gt; .","ref":"Hike.Option.html#t:option/1","title":"Hike.Option.option/1","type":"type"},{"doc":"generic input type &lt;T&gt; .","ref":"Hike.Option.html#t:t/0","title":"Hike.Option.t/0","type":"type"},{"doc":"generic return type &lt;TR&gt; .","ref":"Hike.Option.html#t:tr/0","title":"Hike.Option.tr/0","type":"type"}]